import React from "react";
function Axis(_ref) {
  var radius = _ref.radius,
    showAxisNumbers = _ref.showAxisNumbers,
    _ref$tickMarkHeight = _ref.tickMarkHeight,
    tickMarkHeight = _ref$tickMarkHeight === void 0 ? 5 : _ref$tickMarkHeight,
    _ref$textOffset = _ref.textOffset,
    textOffset = _ref$textOffset === void 0 ? 15 : _ref$textOffset,
    _ref$ringThickness = _ref.ringThickness,
    ringThickness = _ref$ringThickness === void 0 ? 4 : _ref$ringThickness,
    zoomLevel = _ref.zoomLevel;
  var height = (ringThickness + (showAxisNumbers ? textOffset + tickMarkHeight : 0)) / zoomLevel;
  var radiusToUse = showAxisNumbers ? radius + textOffset + tickMarkHeight : radius;
  var component = /*#__PURE__*/React.createElement("g", {
    key: "veAxis",
    className: "veAxis"
  }, /*#__PURE__*/React.createElement("circle", {
    className: "veAxisLine veAxisOuter",
    key: "circleOuter",
    r: radiusToUse + ringThickness,
    style: {
      fill: "#ffffff00",
      stroke: "black",
      strokeWidth: 0.5
    }
  }), /*#__PURE__*/React.createElement("circle", {
    className: "veAxisLine veAxisInner",
    key: "circle",
    r: radiusToUse,
    style: {
      fill: "#ffffff00",
      stroke: "black",
      strokeWidth: 0.5
    }
  }));
  return {
    component: component,
    height: height
  };
}
export default Axis;