import React from "react";
import { startsWith } from "lodash";
import drawDirectedPiePiece from "./drawDirectedPiePiece";
export default function Part(_ref) {
  var radius = _ref.radius,
    _ref$arrowheadLength = _ref.arrowheadLength,
    arrowheadLength = _ref$arrowheadLength === void 0 ? 0.5 : _ref$arrowheadLength,
    annotationHeight = _ref.annotationHeight,
    totalAngle = _ref.totalAngle,
    color = _ref.color,
    overlapsSelf = _ref.overlapsSelf,
    className = _ref.className;
  var path = drawDirectedPiePiece({
    radius: radius,
    overlapsSelf: overlapsSelf,
    annotationHeight: annotationHeight,
    totalAngle: totalAngle,
    arrowheadLength: arrowheadLength,
    tailThickness: 1 //feature specific
  });

  var colorToUse = startsWith(color, "override_") ? color.replace("override_", "") : "#ac68cc";
  return /*#__PURE__*/React.createElement("path", {
    className: className,
    strokeWidth: "0.5",
    stroke: colorToUse
    // fill={colorToUse}
    ,
    d: path.print()
  });
}