"use strict";

exports.__esModule = true;
exports["default"] = DeletionLayer;
var _react = _interopRequireDefault(require("react"));
var _drawDirectedPiePiece = _interopRequireDefault(require("./drawDirectedPiePiece"));
var _excluded = ["color", "radius", "arrowheadLength", "annotationHeight", "totalAngle"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function DeletionLayer(_ref) {
  var _ref$color = _ref.color,
    color = _ref$color === void 0 ? "orange" : _ref$color,
    radius = _ref.radius,
    _ref$arrowheadLength = _ref.arrowheadLength,
    arrowheadLength = _ref$arrowheadLength === void 0 ? 0.5 : _ref$arrowheadLength,
    annotationHeight = _ref.annotationHeight,
    totalAngle = _ref.totalAngle,
    rest = _objectWithoutPropertiesLoose(_ref, _excluded);
  var path = (0, _drawDirectedPiePiece["default"])({
    radius: radius,
    annotationHeight: annotationHeight,
    totalAngle: totalAngle,
    arrowheadLength: arrowheadLength,
    tailThickness: 1 //feature specific
  });

  return /*#__PURE__*/_react["default"].createElement("path", _extends({}, rest, {
    strokeWidth: ".5",
    stroke: "black",
    fill: color,
    d: path.print()
  }));
}
module.exports = exports.default;