"use strict";

exports.__esModule = true;
exports["default"] = Part;
var _react = _interopRequireDefault(require("react"));
var _lodash = require("lodash");
var _drawDirectedPiePiece = _interopRequireDefault(require("./drawDirectedPiePiece"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function Part(_ref) {
  var radius = _ref.radius,
    _ref$arrowheadLength = _ref.arrowheadLength,
    arrowheadLength = _ref$arrowheadLength === void 0 ? 0.5 : _ref$arrowheadLength,
    annotationHeight = _ref.annotationHeight,
    totalAngle = _ref.totalAngle,
    color = _ref.color,
    overlapsSelf = _ref.overlapsSelf,
    className = _ref.className;
  var path = (0, _drawDirectedPiePiece["default"])({
    radius: radius,
    overlapsSelf: overlapsSelf,
    annotationHeight: annotationHeight,
    totalAngle: totalAngle,
    arrowheadLength: arrowheadLength,
    tailThickness: 1 //feature specific
  });

  var colorToUse = (0, _lodash.startsWith)(color, "override_") ? color.replace("override_", "") : "#ac68cc";
  return /*#__PURE__*/_react["default"].createElement("path", {
    className: className,
    strokeWidth: "0.5",
    stroke: colorToUse
    // fill={colorToUse}
    ,
    d: path.print()
  });
}
module.exports = exports.default;