"use strict";

exports.__esModule = true;
exports["default"] = void 0;
var _react = _interopRequireDefault(require("react"));
var _redux = require("redux");
var _withEditorProps = _interopRequireDefault(require("../withEditorProps"));
var _teselagenReactComponents = require("teselagen-react-components");
var _commands = _interopRequireDefault(require("../commands"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
var CommandHotkeyHandler = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(CommandHotkeyHandler, _React$Component);
  function CommandHotkeyHandler(props) {
    var _this;
    _this = _React$Component.call(this, props) || this;
    var commands = (0, _commands["default"])(_assertThisInitialized(_this));
    // Don't bind clipboard shortcuts (use native ones directly)
    ["cut", "copy", "paste"].forEach(function (cmdId) {
      return delete commands[cmdId];
    });
    _this.hotkeyDefs = (0, _teselagenReactComponents.getCommandHotkeys)(commands);
    _this.handlers = (0, _teselagenReactComponents.getCommandHotkeyHandlers)(commands);
    _this.Handler = (0, _teselagenReactComponents.withHotkeys)(_this.hotkeyDefs, _this.handlers);
    return _this;
  }
  var _proto = CommandHotkeyHandler.prototype;
  _proto.render = function render() {
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(this.Handler, {
      key: "handla"
    }), /*#__PURE__*/_react["default"].createElement(_teselagenReactComponents.HotkeysDialog, _extends({
      dialogTitle: "Editor Hotkeys",
      key: "hotkeyDialog",
      hotkeySets: {
        Editor: _extends({
          "Search File Menu": this.props.menuSearchHotkey || "cmd+/"
        }, this.hotkeyDefs)
      }
    }, this.props.hotkeyDialogProps)));
  };
  return CommandHotkeyHandler;
}(_react["default"].Component);
var _default = (0, _redux.compose)(_withEditorProps["default"])(CommandHotkeyHandler);
exports["default"] = _default;
module.exports = exports.default;