"use strict";

exports.__esModule = true;
exports["default"] = getXStartAndWidthOfRowAnnotation;
exports.getWidth = getWidth;
function getXStartAndWidthOfRowAnnotation(range, bpsPerRow, charWidth, gapsBefore, gapsInside) {
  if (gapsBefore === void 0) {
    gapsBefore = 0;
  }
  if (gapsInside === void 0) {
    gapsInside = 0;
  }
  var startOffset = range.start % bpsPerRow;
  var toReturn = {
    startOffset: startOffset,
    xStart: (startOffset + gapsBefore) * charWidth,
    width: getWidth(range, charWidth, gapsInside)
  };
  return toReturn;
}
function getWidth(range, charWidth, gapsInside) {
  if (gapsInside === void 0) {
    gapsInside = 0;
  }
  return (range.end + 1 - range.start + gapsInside) * charWidth;
}