"use strict";

exports.__esModule = true;
exports["default"] = void 0;
var _core = require("@blueprintjs/core");
var _CutsiteFilter = _interopRequireDefault(require("../CutsiteFilter"));
var _react = _interopRequireDefault(require("react"));
var _ToolbarItem = _interopRequireDefault(require("./ToolbarItem"));
var _withEditorProps = require("../withEditorProps");
var _userDefinedHandlersAndOpts = require("../Editor/userDefinedHandlersAndOpts");
var _lodash = require("lodash");
var _excluded = ["editorName", "toggleDropdown", "annotationVisibilityShow", "withDigestTool", "createNewDigest"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
var _default = (0, _withEditorProps.connectToEditor)(function (_ref) {
  var readOnly = _ref.readOnly,
    _ref$annotationVisibi = _ref.annotationVisibility,
    annotationVisibility = _ref$annotationVisibi === void 0 ? {} : _ref$annotationVisibi,
    _ref$toolBar = _ref.toolBar,
    toolBar = _ref$toolBar === void 0 ? {} : _ref$toolBar;
  return {
    readOnly: readOnly,
    toggled: annotationVisibility.cutsites,
    isOpen: toolBar.openItem === "cutsiteTool"
  };
})(function (_ref2) {
  var toolbarItemProps = _ref2.toolbarItemProps,
    toggled = _ref2.toggled,
    isOpen = _ref2.isOpen,
    annotationVisibilityToggle = _ref2.annotationVisibilityToggle;
  return /*#__PURE__*/_react["default"].createElement(_ToolbarItem["default"], _extends({
    Icon: /*#__PURE__*/_react["default"].createElement(_core.Icon, {
      "data-test": "cutsiteHideShowTool",
      icon: "cut"
    }),
    onIconClick: function onIconClick() {
      annotationVisibilityToggle("cutsites");
    },
    toggled: toggled,
    tooltip: "Show cut sites",
    tooltipToggled: "Hide cut sites",
    Dropdown: CutsiteToolDropDown,
    dropdowntooltip: (!isOpen ? "Show" : "Hide") + " Cut Site Options"
  }, toolbarItemProps));
}); // import show_cut_sites_img from "./veToolbarIcons/show_cut_sites.png";
// function CutsiteToolIcon({ annotationVisibilityToggle }) {
//   return (
//     <div
//       onClick={function() {
//         annotationVisibilityToggle("cutsites");
//       }}
//     >
//       <img src={show_cut_sites_img} alt="Show cut sites" />
//     </div>
//   );
// }
exports["default"] = _default;
function CutsiteToolDropDown(_ref3) {
  var editorName = _ref3.editorName,
    toggleDropdown = _ref3.toggleDropdown,
    annotationVisibilityShow = _ref3.annotationVisibilityShow,
    withDigestTool = _ref3.withDigestTool,
    createNewDigest = _ref3.createNewDigest,
    rest = _objectWithoutPropertiesLoose(_ref3, _excluded);
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "veToolbarCutsiteFilterHolder"
  }, /*#__PURE__*/_react["default"].createElement("h6", null, "Filter Cut Sites", " ", /*#__PURE__*/_react["default"].createElement("span", {
    style: {
      fontSize: 12,
      color: "grey"
    }
  }, "(Search by name or # of cuts)")), /*#__PURE__*/_react["default"].createElement(_CutsiteFilter["default"], _extends({}, (0, _lodash.pick)(rest, _userDefinedHandlersAndOpts.userDefinedHandlersAndOpts), {
    editorName: editorName,
    onChangeHook: function onChangeHook() {
      annotationVisibilityShow("cutsites");
    },
    closeDropDown: toggleDropdown
  })), withDigestTool && /*#__PURE__*/_react["default"].createElement(_core.Button, {
    onClick: function onClick() {
      createNewDigest();
      toggleDropdown();
    }
  }, /*#__PURE__*/_react["default"].createElement("span", {
    style: {
      display: "flex"
    }
  }, "Virtual Digest \xA0 ", /*#__PURE__*/_react["default"].createElement(_core.KeyCombo, {
    minimal: true,
    combo: "mod+shift+d"
  }))));
}
module.exports = exports.default;