"use strict";

exports.__esModule = true;
exports["default"] = void 0;
var _react = _interopRequireDefault(require("react"));
var _core = require("@blueprintjs/core");
var _FindBar = _interopRequireDefault(require("../FindBar"));
var _ToolbarItem = _interopRequireDefault(require("./ToolbarItem"));
var _withEditorProps = require("../withEditorProps");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
var _default = (0, _withEditorProps.connectToEditor)(function (_ref) {
  var _ref$findTool = _ref.findTool,
    findTool = _ref$findTool === void 0 ? {} : _ref$findTool;
  return {
    isOpen: findTool.isOpen
  };
})(function (_ref2) {
  var toolbarItemProps = _ref2.toolbarItemProps,
    editorName = _ref2.editorName,
    toggleFindTool = _ref2.toggleFindTool,
    isOpen = _ref2.isOpen;
  return /*#__PURE__*/_react["default"].createElement(_ToolbarItem["default"], _extends({
    Icon: !isOpen ? /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_core.Icon, {
      "data-test": "ve-find-tool-toggle",
      icon: "search"
    }), /*#__PURE__*/_react["default"].createElement(_core.Icon, {
      icon: "caret-right"
    })) : /*#__PURE__*/_react["default"].createElement(_FindBar["default"], {
      editorName: editorName
    }),
    renderIconAbove: isOpen,
    onIconClick: toggleFindTool,
    tooltip: isOpen ? /*#__PURE__*/_react["default"].createElement("span", null, "Hide Find Tool ", /*#__PURE__*/_react["default"].createElement("span", {
      style: {
        fontSize: 10
      }
    }, "(Cmd/Ctrl+F)")) : /*#__PURE__*/_react["default"].createElement("span", null, "Show Find Tool ", /*#__PURE__*/_react["default"].createElement("span", {
      style: {
        fontSize: 10
      }
    }, "(Cmd/Ctrl+F)"))
  }, toolbarItemProps));
});
exports["default"] = _default;
module.exports = exports.default;