"use strict";

exports.__esModule = true;
exports["default"] = void 0;
var _core = require("@blueprintjs/core");
var _react = _interopRequireDefault(require("react"));
var _ToolbarItem = _interopRequireDefault(require("./ToolbarItem"));
var _withEditorProps = require("../withEditorProps");
var _partTagSearch = require("../helperComponents/partTagSearch");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
var _default = (0, _withEditorProps.connectToEditor)(function (_ref) {
  var _ref$annotationVisibi = _ref.annotationVisibility,
    annotationVisibility = _ref$annotationVisibi === void 0 ? {} : _ref$annotationVisibi,
    _ref$toolBar = _ref.toolBar,
    toolBar = _ref$toolBar === void 0 ? {} : _ref$toolBar;
  return {
    toggled: annotationVisibility.parts,
    isOpen: toolBar.openItem === "partTool"
  };
})(function (_ref2) {
  var allPartTags = _ref2.allPartTags,
    editTagsLink = _ref2.editTagsLink,
    toolbarItemProps = _ref2.toolbarItemProps,
    toggled = _ref2.toggled,
    annotationVisibilityToggle = _ref2.annotationVisibilityToggle,
    isOpen = _ref2.isOpen;
  return /*#__PURE__*/_react["default"].createElement(_ToolbarItem["default"], _extends({
    Icon: /*#__PURE__*/_react["default"].createElement(_core.Icon, {
      icon: "doughnut-chart"
    }),
    onIconClick: function onIconClick() {
      annotationVisibilityToggle("parts");
    },
    toggled: toggled,
    editTagsLink: editTagsLink,
    allPartTags: allPartTags,
    tooltip: "Show parts",
    tooltipToggled: "Hide parts",
    noDropdownIcon: !allPartTags,
    Dropdown: _partTagSearch.PartTagSearch,
    dropdowntooltip: (!isOpen ? "Show" : "Hide") + " Part Options"
  }, toolbarItemProps));
});
exports["default"] = _default;
module.exports = exports.default;