"use strict";

exports.__esModule = true;
exports["default"] = void 0;
var _react = _interopRequireDefault(require("react"));
var _teselagenReactComponents = require("teselagen-react-components");
var _lodash = require("lodash");
var _CutsiteFilter = _interopRequireDefault(require("../../CutsiteFilter"));
var _core = require("@blueprintjs/core");
var _withEditorProps = require("../../withEditorProps");
var _recompose = require("recompose");
var _selectors = _interopRequireDefault(require("../../selectors"));
var _commands = _interopRequireDefault(require("../../commands"));
var _userDefinedHandlersAndOpts = require("../../Editor/userDefinedHandlersAndOpts");
var _SingleEnzymeCutsiteInfo = _interopRequireDefault(require("./SingleEnzymeCutsiteInfo"));
var _withRestrictionEnzymes = require("../../CutsiteFilter/withRestrictionEnzymes");
var _viewSubmenu = require("../../MenuBar/viewSubmenu");
var _GenericAnnotationProperties = require("./GenericAnnotationProperties");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var CutsiteProperties = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(CutsiteProperties, _React$Component);
  function CutsiteProperties(props) {
    var _this;
    _this = _React$Component.call(this, props) || this;
    _defineProperty(_assertThisInitialized(_this), "SubComponent", function (row) {
      return /*#__PURE__*/_react["default"].createElement(_SingleEnzymeCutsiteInfo["default"], {
        allRestrictionEnzymes: _this.props.allRestrictionEnzymes,
        allCutsites: _this.props.allCutsites,
        filteredCutsites: _this.props.filteredCutsites,
        editorName: _this.props.editorName,
        dispatch: _this.props.dispatch,
        selectedAnnotationId: _this.props.selectedAnnotationId,
        cutsiteGroup: row.original.cutsiteGroup,
        enzyme: row.original.enzyme
      });
    });
    _defineProperty(_assertThisInitialized(_this), "schema", {
      fields: [{
        path: "name",
        type: "string"
      }, {
        path: "numberOfCuts",
        type: "number"
      }, {
        path: "groups",
        type: "string"
      }]
    });
    _defineProperty(_assertThisInitialized(_this), "onChangeHook", function () {
      _this.props.annotationVisibilityShow("cutsites");
    });
    _this.commands = (0, _commands["default"])(_assertThisInitialized(_this));
    return _this;
  }
  var _proto = CutsiteProperties.prototype;
  _proto.render = function render() {
    var _this$props = this.props,
      editorName = _this$props.editorName,
      createNewDigest = _this$props.createNewDigest,
      allCutsites = _this$props.filteredCutsites,
      selectedAnnotationId = _this$props.selectedAnnotationId;
    var cutsitesByName = allCutsites.cutsitesByName,
      cutsitesById = allCutsites.cutsitesById;
    var cutsitesToUse = (0, _lodash.map)(cutsitesByName, function (cutsiteGroup) {
      var name = cutsiteGroup[0].restrictionEnzyme.name;
      var groups = "";
      var exisitingEnzymeGroups = window.getExistingEnzymeGroups();
      Object.keys(exisitingEnzymeGroups).forEach(function (key) {
        if (exisitingEnzymeGroups[key].includes(name)) groups += key;
        groups += " ";
      });
      return {
        cutsiteGroup: cutsiteGroup,
        id: name,
        name: name,
        numberOfCuts: cutsiteGroup.length,
        enzyme: cutsiteGroup[0].restrictionEnzyme,
        groups: groups
        // size: getRangeLength(cutsiteGroup, sequenceData.sequence.length)
      };
    });

    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
      style: {
        marginBottom: 10,
        paddingTop: 3,
        display: "flex",
        // flexWrap: 'wrap',
        width: "100%",
        // justifyContent: "space-between",
        alignItems: "center"
      }
    }, (0, _GenericAnnotationProperties.getVisFilter)((0, _teselagenReactComponents.createCommandMenu)(_viewSubmenu.cutsitesSubmenu, this.commands, {
      useTicks: true
    })), /*#__PURE__*/_react["default"].createElement(_core.ButtonGroup, null, /*#__PURE__*/_react["default"].createElement(_core.Button, {
      intent: "success",
      "data-tip": "Virtual Digest",
      icon: "cut",
      style: {
        marginLeft: 15,
        flexGrow: -1
      },
      onClick: function onClick() {
        createNewDigest();
      }
    })), /*#__PURE__*/_react["default"].createElement(_CutsiteFilter["default"], _extends({}, (0, _lodash.pick)(this.props, _userDefinedHandlersAndOpts.userDefinedHandlersAndOpts), {
      style: {
        marginLeft: "auto",
        marginRight: 3
      },
      editorName: editorName,
      manageEnzymesToLeft: true,
      onChangeHook: this.onChangeHook
    }))), /*#__PURE__*/_react["default"].createElement(_teselagenReactComponents.DataTable, {
      selectedIds: (0, _lodash.get)(cutsitesById[selectedAnnotationId], "restrictionEnzyme.name"),
      compact: true,
      noSelect: true,
      noHeader: true,
      noFooter: true,
      withExpandAndCollapseAllButton: true,
      noFullscreenButton: true,
      noPadding: true,
      defaults: {
        order: ["numberOfCuts"]
      },
      formName: "cutsiteProperties",
      noRouter: true,
      withSearch: false,
      SubComponent: this.SubComponent,
      isInfinite: true,
      schema: this.schema,
      entities: cutsitesToUse
    }));
  };
  return CutsiteProperties;
}(_react["default"].Component);
var _default = (0, _recompose.compose)((0, _withEditorProps.connectToEditor)(function (editorState, ownProps) {
  var cutsites = _selectors["default"].filteredCutsitesSelector(editorState, ownProps.additionalEnzymes, ownProps.enzymeGroupsOverride);
  var allCutsites = _selectors["default"].cutsitesSelector(editorState, ownProps.additionalEnzymes);
  return {
    annotationVisibility: editorState.annotationVisibility || {},
    filteredCutsites: cutsites,
    allCutsites: allCutsites,
    cutsites: cutsites.cutsitesArray
  };
}), _withRestrictionEnzymes.withRestrictionEnzymes, (0, _teselagenReactComponents.withSelectedEntities)("cutsiteProperties"))(CutsiteProperties);
exports["default"] = _default;
module.exports = exports.default;