"use strict";

exports.__esModule = true;
exports["default"] = void 0;
var _react = _interopRequireDefault(require("react"));
var _teselagenReactComponents = require("teselagen-react-components");
var _lodash = require("lodash");
var _rangeUtils = require("@teselagen/range-utils");
var _orfFrameToColorMap = require("../../constants/orfFrameToColorMap");
var _withEditorProps = require("../../withEditorProps");
var _recompose = require("recompose");
var _selectors = _interopRequireDefault(require("../../selectors"));
var _commands = _interopRequireDefault(require("../../commands"));
var _utils = require("./utils");
var _viewSubmenu = require("../../MenuBar/viewSubmenu");
var _GenericAnnotationProperties = require("./GenericAnnotationProperties");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var OrfProperties = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(OrfProperties, _React$Component);
  function OrfProperties(props) {
    var _this;
    _this = _React$Component.call(this, props) || this;
    _defineProperty(_assertThisInitialized(_this), "onRowSelect", function (_ref) {
      var record = _ref[0];
      if (!record) return;
      var _this$props = _this.props,
        dispatch = _this$props.dispatch,
        editorName = _this$props.editorName;
      dispatch({
        type: "SELECTION_LAYER_UPDATE",
        payload: record,
        meta: {
          editorName: editorName
        }
      });
    });
    _this.commands = (0, _commands["default"])(_assertThisInitialized(_this));
    return _this;
  }
  var _proto = OrfProperties.prototype;
  _proto.render = function render() {
    var _this$props2 = this.props,
      orfs = _this$props2.orfs,
      sequenceLength = _this$props2.sequenceLength,
      annotationVisibility = _this$props2.annotationVisibility;
    var orfsToUse = (0, _lodash.map)(orfs, function (orf) {
      return _extends({}, orf, {
        color: (0, _orfFrameToColorMap.getOrfColor)(orf),
        frame: orf.frame + 1
      }, orf.strand === undefined && {
        strand: orf.forward ? 1 : -1
      }, {
        size: (0, _rangeUtils.getRangeLength)(orf, sequenceLength),
        sizeAa: Math.floor((0, _rangeUtils.getRangeLength)(orf, sequenceLength) / 3 - 1)
      });
    });
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_teselagenReactComponents.DataTable, {
      topLeftItems: (0, _GenericAnnotationProperties.getVisFilter)((0, _teselagenReactComponents.createCommandMenu)(_viewSubmenu.orfsSubmenu, this.commands, {
        useTicks: true
      })),
      annotationVisibility: annotationVisibility //we need to pass this in order to force the DT to rerender
      ,
      noPadding: true,
      noFullscreenButton: true,
      onRowSelect: this.onRowSelect,
      withSearch: false,
      formName: "orfProperties",
      noRouter: true,
      compact: true,
      isInfinite: true,
      schema: {
        fields: [{
          path: "color",
          type: "string",
          render: function render(color) {
            return /*#__PURE__*/_react["default"].createElement("div", {
              style: {
                height: 20,
                width: 20,
                background: color
              }
            });
          }
        }, {
          path: "sizeAa",
          displayName: "Size (aa)",
          type: "number"
        }, _utils.sizeSchema, {
          path: "frame",
          type: "number"
        }, {
          path: "strand",
          type: "number"
        }]
      },
      entities: orfsToUse
    }), /*#__PURE__*/_react["default"].createElement("br", null));
  };
  return OrfProperties;
}(_react["default"].Component);
var _default = (0, _recompose.compose)((0, _withEditorProps.connectToEditor)(function (editorState) {
  var readOnly = editorState.readOnly,
    _editorState$annotati = editorState.annotationVisibility,
    annotationVisibility = _editorState$annotati === void 0 ? {} : _editorState$annotati,
    _editorState$sequence = editorState.sequenceData;
  _editorState$sequence = _editorState$sequence === void 0 ? {} : _editorState$sequence;
  var _editorState$sequence2 = _editorState$sequence.sequence,
    sequence = _editorState$sequence2 === void 0 ? "" : _editorState$sequence2,
    sequenceData = editorState.sequenceData,
    minimumOrfSize = editorState.minimumOrfSize,
    useAdditionalOrfStartCodons = editorState.useAdditionalOrfStartCodons;
  return {
    readOnly: readOnly,
    annotationVisibility: annotationVisibility,
    useAdditionalOrfStartCodons: useAdditionalOrfStartCodons,
    orfs: _selectors["default"].orfsSelector(editorState),
    sequenceLength: sequence.length,
    sequenceData: sequenceData,
    minimumOrfSize: minimumOrfSize
  };
}), (0, _teselagenReactComponents.withSelectedEntities)("orfProperties"))(OrfProperties);
exports["default"] = _default;
module.exports = exports.default;